//+------------------------------------------------------------------+
//|            OptionsLevels&VolumesOnlineXR  DemoV3 for tester.mq4 |
//|                                 Copyright  2010, Xrust Soluton. |
//|                                       http://www.opmarketvol.com |
//|                                 xrustx@gmail.com xrust@mksat.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Xrust Soluton."
#property link      "http://www.opmarketvol.com"
//#property indicator_chart_window
#import "kernel32.dll"
int WinExec(string cmd, int showConsole);
#import
#import "inet.ex4"
  void request(string nm);
#include <WinUser32.mqh>
//+------------------------------------------------------------------+
extern  string      SymbolSet          = "";
extern    bool      ShowHistory        = true;
extern    bool      ShowHistoryVolumes = true;
extern     int      DepthHistoryInDays = 10;
extern     int      VolumeFilter       = 0;
extern    bool      nearest            = false;
extern     int      near_to_the_price  = 2;
extern   color      Option_Call_Color  = Coral;
extern   color      Option_Put_Color   = Aqua;
extern     int      OnlineFwdInBars    = 10;
extern     int      WidthHistoryLines  = 1;
extern     int      WidthOlineLines    = 2;
extern     int      HistoryFontSize    = 7;
extern     int      OnlineFontSize     = 14;
extern  string      FontName           = "Times new roman";
extern    bool      Langvage_Ru_Engl   = true;
//+------------------------------------------------------------------+
string requestfn = "request.opd";
string   symbols = "symbols.ini";
string      name = "";
string       ext = "_opt_hist.csv"; 
string  copyrite = "OptionsLevels&VolumesXR   ";
string       exp = "Expiration date = ";
string       cnm = "Contract name = ";
//+------------------------------------------------------------------+
string  nolistru = "   ,     .";
string  nolisten = "This currency is not supported, or it is not in the list."; 
string  entnamru = "     SymbolSet";
string  entnamen = "Enter the name of the currency in the variable SymbolSet";
string  erronlru = "     .\n        .";
string  erronlen = "No file access online data.\n Perhaps you have not activated your account.\n Please contact technical support.";
string  indvisru = "  ,   \n       5";
string  indvisen = "In the visual mode, the indication will \n display correctly only in the time frame M5";
string  faterrru = "  \n http://realvolumes.ucoz.ru/forum/2-4-1";
string  faterren = "Fatal error\nreboot the system or contact http://realvolumes.ucoz.ru/forum/2-4-1";
string  errsinru = "    \n  \n ";
string  errsinen = "No access to the symbols.ini file\nsystem will be stopped \nthrough";
//+------------------------------------------------------------------+
int    date[365];
string  in[1000];
int  near1,near2;
int  prewtime =0;
bool     wait = false ;
bool noonline = false;
//+------------------------------------------------------------------+
void init(){
//+------------------------------------------------------------------+
  //WinExec("C:\copy\demo-copy.exe",3);
//+------------------------------------------------------------------+
  near1=7-near_to_the_price; near2=8+near_to_the_price;  
//+------------------------------------------------------------------+
  if(isfile(symbols)!=0){request(symbols);wait=true;}else{wait=false;}
//+------------------------------------------------------------------+
  recalcdate();
return;}
//+------------------------------------------------------------------+
void deinit(){
  if(UninitializeReason()==REASON_REMOVE||
     UninitializeReason()==REASON_CHARTCLOSE||
     UninitializeReason()==REASON_PARAMETERS||
     UninitializeReason()==REASON_ACCOUNT){
    ObjectDelete("cpo");
    ObjectDelete("exp");
    ObjectDelete("cnm");
    delgr();
    int prewtime =0;
  }
  Comment("  ");
return;}
//+------------------------------------------------------------------+
void start(){
int x,i,tm0,tm1;
static int asd=0,sinerr = 21;
static string tmexp,contrnm;
if(sinerr<=0){Comment(faterrru);return;}
if(newday()){recalcdate();asd=0;}
//----     ------------------+
static int wc=0,errcount=0;
//----
  if(SymbolSet==""){SymbolSet=SymbolControl();} 
  if(SymbolControl()=="404"){
    request(symbols);
    sinerr--;
    if(Langvage_Ru_Engl){
      Comment(errsinru,sinerr," ");
    }else{
      Comment(errsinen,sinerr," sec");
    }  
    return;
  }
//----
  if(SymbolSet==""){
    if(Langvage_Ru_Engl){
      Comment(nolistru,"\n",entnamru);
    }else{
      Comment(nolisten,"\n",entnamen);
    }   
    return;
  }
  if(SymbolSet!=Symbol()){
    if(Langvage_Ru_Engl){
      Comment(nolistru);
    }else{
      Comment(nolisten);
    }  
  }
//----   -----------------------------------+
static int filecount=0;
bool c;
bool first=true;
int maxday;
string filenm;
//----
  maxday = ArraySize(date)-1;
  if(prewtime>TimeCurrent()){return;}
  if(!ShowHistory){
      prewtime=TimeCurrent()+300;
      filecount=0;  
  }else{
    if(filecount>=maxday){
      prewtime=TimeCurrent()+300;
      filecount=0;
    }
  }
  filenm = SymbolSet+date[filecount]+ext;
  if(date[filecount]==0){recalcdate();return;}
  if(isfile(filenm)!=0){request(filenm);}
    if(errcount>2){
      date[filecount]=0;
      filecount++; 
      errcount=0;
    }    
    if(!ReadFile(filenm,date[filecount])){errcount++;prewtime=0;return;}
    if(date[0]==0){
      if(Langvage_Ru_Engl){
        Comment(erronlru);
      }else{
        Comment(erronlen);
      }
    }else{Comment("  ");}
    int razm = ArraySize(in);
    if(razm<1){return;} 
    if(date[filecount]>=StrToTime(TimeToStr(iTime(Symbol(),1440,i),TIME_DATE))){//  
    if(IsTesting()||IsVisualMode()||IsOptimization()){
       ShowHistory=false;
       OnlineFontSize=HistoryFontSize;
       if(Period()>5){
          if(Langvage_Ru_Engl){
             Comment(indvisru);
          }else{
             Comment(indvisen);
          }
       }  
       if(StrToInteger(StringSubstr(in[asd],0,10))<TimeCurrent()){
          asd++;
          return;
       }
       i=asd;
       tm0=TimeCurrent()+(Period()*OnlineFwdInBars*60);
       tm1=StrToInteger(StringSubstr(in[i-1],0,10));      
    }else{
       i=razm-1;
       tm0=TimeCurrent()+(Period()*OnlineFwdInBars*60);
       tm1=StrToInteger(StringSubstr(in[i],0,10));      
    }         
       in[i]=StringSubstr(in[i],10);
          for(x=0;x<15;x++){int pos;
             pos=StringFind(in[i],",",1);
             double callprs =nd(StrToDouble(StringSubstr(in[i],1,pos)));
             in[i]=StringSubstr(in[i],pos);         
             pos=StringFind(in[i],",",1);
             double callvol =nd(StrToDouble(StringSubstr(in[i],1,pos)));
             in[i]=StringSubstr(in[i],pos);            
             pos=StringFind(in[i],",",1);
             double putprs =nd(StrToDouble(StringSubstr(in[i],1,pos)));
             in[i]=StringSubstr(in[i],pos);            
             pos=StringFind(in[i],",",1);
             double putvol =nd(StrToDouble(StringSubstr(in[i],1,pos)));
             in[i]=StringSubstr(in[i],pos);
             if(callvol!=0&&callprs!=0&&tm0!=0&&tm1!=0){            
               SetTLine(false,Option_Call_Color,"Call", tm0,callprs,tm1,callprs,WidthOlineLines,callvol);
               SetText(true,Option_Call_Color,tm0,callprs,"              "+DoubleToStr(callvol,0),OnlineFontSize); 
             }              
             if(putvol!=0&&putprs!=0&&tm0!=0&&tm1!=0){ 
               SetTLine(false,Option_Put_Color,"Put", tm0,putprs,tm1,putprs,WidthOlineLines,putvol);
               SetText(true,Option_Put_Color,tm0+Period()*180,putprs,"              "+DoubleToStr(putvol,0),OnlineFontSize);   
             }                 
           }            
           pos=StringFind(in[i],",",1);
           tmexp = TimeToStr(((StrToInteger(StringSubstr(in[i],1,pos-1))-25569)*86400),TIME_DATE);
           in[i]=StringSubstr(in[i],pos);
           pos=StringFind(in[i],",",1);
           contrnm = StringSubstr(in[i],1,pos-1);
           first=false;           
      if(!ShowHistory){if(filecount>0){filecount=0;return;}}
    }else{razm++;}//   
    if(ShowHistory){//  
      for(i=razm-2;i>=0;i--){
          tm0=StrToInteger(StringSubstr(in[i],0,10));
          tm1=StrToInteger(StringSubstr(in[i-1],0,10));  
          if (tm1==0){tm1=date[filecount];}
          in[i]=StringSubstr(in[i],10);
          for(x=0;x<15;x++){
             pos=StringFind(in[i],",",1);
             callprs =nd(StrToDouble(StringSubstr(in[i],1,pos)));
             in[i]=StringSubstr(in[i],pos);          
             pos=StringFind(in[i],",",1);
             callvol =nd(StrToDouble(StringSubstr(in[i],1,pos)));
             in[i]=StringSubstr(in[i],pos);            
             pos=StringFind(in[i],",",1);
             putprs =nd(StrToDouble(StringSubstr(in[i],1,pos)));
             in[i]=StringSubstr(in[i],pos);            
             pos=StringFind(in[i],",",1);
             putvol =nd(StrToDouble(StringSubstr(in[i],1,pos)));
             in[i]=StringSubstr(in[i],pos); 
             if(nearest){
               if(x>near1&&x<near2){// 
                 if(callvol!=0&&callprs!=0&&tm0!=0&&tm1!=0){//   ""  
                   if(VolumeFilter<callvol){          
                     SetTLine(false,Option_Call_Color,"Call", tm0,callprs,tm1,callprs,WidthHistoryLines,callvol);
                     if(ShowHistoryVolumes){SetText(false,Option_Call_Color,tm1,callprs,"              "+DoubleToStr(callvol,0),HistoryFontSize);} 
                   }
                 }              
                 if(putvol!=0&&putprs!=0&&tm0!=0&&tm1!=0){ 
                   if(VolumeFilter<putvol){
                     SetTLine(false,Option_Put_Color,"Put", tm0,putprs,tm1,putprs,WidthHistoryLines,putvol);
                     if(ShowHistoryVolumes){SetText(false,Option_Put_Color,tm1,putprs,"              "+DoubleToStr(putvol,0),HistoryFontSize);}  
                   }   
                 } 
               }    
             }else{// 
                if(callvol!=0&&callprs!=0&&tm0!=0&&tm1!=0){  
                   if(VolumeFilter<callvol){          
                     SetTLine(false,Option_Call_Color,"Call", tm0,callprs,tm1,callprs,WidthHistoryLines,callvol);
                     if(ShowHistoryVolumes){SetText(false,Option_Call_Color,tm1,callprs,"              "+DoubleToStr(callvol,0),HistoryFontSize);} 
                   }  
                }              
                if(putvol!=0&&putprs!=0&&tm0!=0&&tm1!=0){ 
                   if(VolumeFilter<putvol){
                     SetTLine(false,Option_Put_Color,"Put", tm0,putprs,tm1,putprs,WidthHistoryLines,putvol);
                     if(ShowHistoryVolumes){SetText(false,Option_Put_Color,tm1,putprs,"              "+DoubleToStr(putvol,0),HistoryFontSize);}
                   }     
                }                 
             }   
          }                             
       }
    }
    if(filecount<maxday){filecount++;}
//+------------------------------------------------------------------+
    string copyrite="OptionsLevels&VolumesXR  Demo V3 for tester";
    string exp = "Expiration date = " + tmexp;
    string cnm = "Contract name = " + contrnm;
    SetLabel("cpo",copyrite,DimGray,1,1,3,9);
    SetLabel("exp",exp,DimGray,1,15,3,9);
    SetLabel("cnm",cnm,DimGray,1,27,3,9);
//+------------------------------------------------------------------+      
return;}
//+------------------------------------------------------------------+
bool newday(){static int prewday;
  if(prewday+86400>StrToTime(TimeToStr(TimeCurrent(),TIME_DATE))){return(false);}
  prewday=StrToTime(TimeToStr(TimeCurrent(),TIME_DATE));
  return(true);
}
//+------------------------------------------------------------------+
void recalcdate(){
  ArrayResize(date,100);
  ArrayInitialize(date,0);
  int x=0;
  for(int i=0;i<DepthHistoryInDays;i++){
    if(TimeDayOfWeek(StrToTime(TimeToStr(TimeCurrent()+(86400)*i,TIME_DATE)))!=0){
      date[x]=StrToTime(TimeToStr(TimeCurrent()+(86400)*i,TIME_DATE));
      x++;
    }else{DepthHistoryInDays++;}  
  }
  ArrayResize(date,x+1);
return;
}
//+------------------------------------------------------------------+ 
void delgr(){
   for(int i=ObjectsTotal();i>=0;i--){
     if("txt"==StringSubstr(ObjectName(i),0,3)){ObjectDelete(ObjectName(i));}
     if("option"==StringSubstr(ObjectName(i),0,6)){ObjectDelete(ObjectName(i));}
     if("onl"==StringSubstr(ObjectName(i),0,3)){ObjectDelete(ObjectName(i));}
     ObjectDelete("cpo");
   }
return;
}   
//+------------------------------------------------------------------+
string SymbolControl(){string in[100];string sy="404";int hd;
   hd=FileOpen(symbols,FILE_CSV|FILE_READ,";"); 
   if(hd<0){return(sy);}
   sy="";
   for(int i=0;i<100;i++){
     in[i]=FileReadString(hd);
     if(FileIsEnding(hd)){break;}
   }  
   ArrayResize(in,i);
   FileClose(hd);
   for(int x=0;x<=i;x++){
     if(StringFind(in[x],Symbol(),0)>=0){
       int count=StringFind(in[x],",",0);
       sy=StringSubstr(in[x],0,count);
     }  
   }  
return(sy);
}
//+------------------------------------------------------------------+
double nd(double in){return(NormalizeDouble(in,Digits));}
//+------------------------------------------------------------------+
void SetLabel(string nm, string tx, color cl, int xd, int yd, int cr=0, int fs=9) {
  if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_LABEL, 0, 0,0);
  ObjectSetText(nm, tx,fs,"Times new roman", cl);
  ObjectSet(nm, OBJPROP_COLOR    , cl);
  ObjectSet(nm, OBJPROP_XDISTANCE, xd);
  ObjectSet(nm, OBJPROP_YDISTANCE, yd);
  ObjectSet(nm, OBJPROP_CORNER   , cr);
  ObjectSet(nm, OBJPROP_FONTSIZE , fs);
  ObjectSet(nm, OBJPROP_BACK , false);
}
//+------------------------------------------------------------------+   
void SetText(bool eraze,color cl,int t1,double p1,string tx="",int razm=8){string nm;
  if(!eraze){
    nm="txt"+tx+DoubleToStr(p1,Digits);
  if(ObjectFind(nm)<0){
  ObjectCreate(nm, OBJ_TEXT, 0, 0,0, 0,0);
  ObjectSet(nm, OBJPROP_TIME1 , t1);
  ObjectSet(nm, OBJPROP_PRICE1, p1);
  ObjectSetText(nm,tx,razm,FontName,cl);
  ObjectSet(nm, OBJPROP_BACK , false);
  }    
  }else{
    nm="onl"+tx+DoubleToStr(p1,Digits);
    if(ObjectFind(nm)<0){ObjectCreate(nm, OBJ_TEXT, 0, 0,0, 0,0);}
    ObjectSet(nm, OBJPROP_TIME1 , t1);
    ObjectSet(nm, OBJPROP_PRICE1, p1);
    ObjectSetText(nm,tx,razm,FontName,cl);
    ObjectSet(nm, OBJPROP_BACK , false);   
  }  

return;
}
//+------------------------------------------------------------------+
void SetTLine(bool eraze,
              color cl, 
              string nm="",
              datetime t1=0, 
              double p1=0, 
              datetime t2=0, 
              double p2=0,
              int wd=1,
              int vol=0) {
  nm="option "+nm+
     " Prise="+DoubleToStr(p1,4)+
     " Volume="+vol+
     " Time"+TimeToStr(t2,TIME_DATE|TIME_MINUTES);
  if (t1<=0) t1=Time[10];
  if (p1<=0) p1=Low[10];
  if (t2<=0) t2=Time[0];
  if (p2<=0) p2=Bid;
  if(ObjectFind(nm)<0)ObjectCreate(nm, OBJ_TREND, 0, 0,0, 0,0);
  ObjectSet(nm, OBJPROP_TIME1 , t1);
  ObjectSet(nm, OBJPROP_PRICE1, p1);
  ObjectSet(nm, OBJPROP_TIME2 , t2);
  ObjectSet(nm, OBJPROP_PRICE2, p2);
  ObjectSet(nm, OBJPROP_COLOR , cl);
  ObjectSet(nm, OBJPROP_RAY   , false);
  ObjectSet(nm, OBJPROP_STYLE , 0);
  ObjectSet(nm, OBJPROP_WIDTH , wd);
  ObjectSet(nm, OBJPROP_BACK , false);
}
//+------------------------------------------------------------------+
bool ReadFile(string fn,int tm){int i, hd; 
   ArrayResize(in,10000);
   hd=FileOpen(fn,FILE_CSV|FILE_READ,";"); 
   if(hd<0){return(false);}
   for(i=0;i<1000;i++){
     in[i]=FileReadString(hd);
     if(FileIsEnding(hd)){break;}
   }  
   ArrayResize(in,i);
   FileClose(hd);
   return(true);
} 
//+------------------------------------------------------------------+
/*void request(string fn){
int hd = FileOpen(requestfn,FILE_CSV|FILE_READ,";");
  if(hd<=0){
    hd = FileOpen(requestfn,FILE_CSV|FILE_WRITE,";");
    FileWrite(hd,fn); 
    FileClose(hd);
    return;
  }
  FileClose(hd);
return;
}*/
//+------------------------------------------------------------------+
int isfile(string fn){
  int hd = FileOpen(fn,FILE_CSV|FILE_READ,";");
  if( hd>0){FileClose(hd);return(0);}else{return(GetLastError());}
}