//+------------------------------------------------------------------+
//|                                       Open interest XR  V35.mq4 |
//|                                 Copyright  2010, Xrust Soluton. |
//|                                       http://www.opmarketvol.com |
//|                                 xrustx@gmail.com xrust@mksat.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Xrust Soluton."
#property link      "http://www.opmarketvol.com"
#property indicator_chart_window
#import "user32.dll"
   int GetWindowDC(int dc);
   int ReleaseDC(int h, int dc);
  bool GetWindowRect(int h, int& pos[4]);
#import
#import "gdi32.dll"
   int GetPixel(int dc, int x, int y);
#import
#import "kernel32.dll"
int WinExec(string cmd, int showConsole);
int  GetTimeZoneInformation(int& TZInfoArray[]);
#import
#import "inet.ex4"
  void request(string nm);
#include <WinUser32.mqh>
//+------------------------------------------------------------------+
extern  string      SymbolSet          = "";
extern    bool      ShowHistory        = true;
extern    bool      ShowText           = true;
extern    bool      FillRestangle      = true;
extern     int      DepthHistoryInDays = 3;
extern     int      VolumeFilter       = 0;
extern    bool      ShowNearest        = true;
extern     int      Britness           = 0;
extern     int      OnlineFwdInBars    = 10;
extern     int      FontSize           = 9;
extern  string      FontName           = "Times new roman";
bool      Langvage_Ru_Engl   = true;
//+------------------------------------------------------------------+
string requestfn = "request.opd";
string   symbols = "symbols.ini";
string      name = "";
string       ext = "_hist_OI.csv"; 
string  copyrite = "Open Interest Online indicatorXR  Demo V3 ";
string       exp = "Expiration date = ";
string       cnm = "Contract name = ";
//+------------------------------------------------------------------+
string  nolistru = "   ,     .";
string  nolisten = "This currency is not supported, or it is not in the list."; 
string  entnamru = "     SymbolSet";
string  entnamen = "Enter the name of the currency in the variable SymbolSet";
string  erronlru = "     .\n        .\n   .";
string  erronlen = "No file access online data.\n Perhaps you have not activated your account.\n Please contact technical support.";
string  indvisru = "  ,   \n       5";
string  indvisen = "In the visual mode, the indication will \n display correctly only in the time frame M5";
string  faterrru = "  \n http://realvolumes.ucoz.ru/forum/2-4-1";
string  faterren = "Fatal error\nreboot the system or contact http://realvolumes.ucoz.ru/forum/2-4-1";
string  errsinru = "    \n  \n ";
string  errsinen = "No access to the symbols.ini file\nsystem will be stopped \nthrough";
string  zapflru  = "    ";
string  zapflen  = "Wait, reqwest server ";
string  readflru = "    ";
string  readflen = "Wait read file ";
string  errdayru = ",      D1,   ";
string  errdayen = "Wait, is History download for D1 TimeFrame, or upload your own";
//+------------------------------------------------------------------+
int    date[365];
int       tz[43];
string  in[100];
string  oi[1];
int  near1,near2;
int  prewtime =0;
bool     wait = false ;
bool noonline = false;
int Win_color;
int days;
//+------------------------------------------------------------------+
void init(){days=DepthHistoryInDays;
//+------------------------------------------------------------------+
  if(isfile(symbols)!=0){request(symbols);wait=true;}else{wait=false;}
//+------------------------------------------------------------------+  
  int hd=FileOpen("opml.tmp",FILE_CSV|FILE_READ);
  if(hd>0){FileReadString(hd);
  if(FileReadString(hd)==".en"){Langvage_Ru_Engl=false;}else{Langvage_Ru_Engl=true;}
  FileClose(hd);
  }  
//+------------------------------------------------------------------+  
   for(int i=0;i<100;i++){
     if(iTime(Symbol(),1440,i)<1){
       i--;
       if(Langvage_Ru_Engl){
         Comment(errdayru);
       }else{
         Comment(errdayen);
       }
     }
   }  
//+------------------------------------------------------------------+
  recalcdate();
return;}
//+------------------------------------------------------------------+
void deinit(){
  if(UninitializeReason()==REASON_REMOVE||
     UninitializeReason()==REASON_CHARTCLOSE||
     UninitializeReason()==REASON_PARAMETERS||
     UninitializeReason()==REASON_RECOMPILE||
     UninitializeReason()==REASON_ACCOUNT){
    ObjectDelete("oicpo");
    ObjectDelete("oiexp");
    ObjectDelete("oicnm");
    ObjectDelete("oiacl");
    ObjectDelete("oiapt");
    delgr();
    prewtime =0;
  }
  Comment("  ");
return;}
//+------------------------------------------------------------------+
bool busy(){if(GlobalVariableCheck("busy")){return(true);}else{return(false);}}
//+------------------------------------------------------------------+
void start(){static int pc =0;int col;
int x,i;static int tm0,tm1;
static int asd=0,sinerr = 21;
static string tmexp,contrnm,allcalls,allputs;
if(sinerr<=0){
       if(Langvage_Ru_Engl){
         Comment(faterrru);
       }else{
         Comment(faterren);
       }
  return;
}
if(iTime(Symbol(),1440,i)<1){
       if(Langvage_Ru_Engl){
         Comment(faterrru,"\n    D1");
       }else{
         Comment(faterren,"\nEnough history on D1 TimeFrame");
       }
  return;
}
if(newday()){recalcdate();asd=0;}//      
col = GetWndColor(Symbol());
if(col>0){color txcol=Black;}else{txcol=White;}
if(col!=pc){pc=col;prewtime=0;}
int hd=FileOpen("opml.tmp",FILE_CSV|FILE_READ);
if(hd>0){FileReadString(hd);
  if(FileReadString(hd)==".en"){Langvage_Ru_Engl=false;}else{Langvage_Ru_Engl=true;}
  FileClose(hd);
}
//+------------------------------------------------------------------+
if(TimeCurrent()<prewtime){return;}
prewtime=TimeCurrent()+300;
//delgr();
//----     ------------------+
static int wc=0,errcount=0;
//----
  if(SymbolSet==""){SymbolSet=SymbolControl();} 
  if(SymbolControl()=="404"){
    request(symbols);
    sinerr--;
    if(Langvage_Ru_Engl){
      Comment(errsinru,sinerr," ");
    }else{
      Comment(errsinen,sinerr," sec");
    } 
    prewtime=0; 
    return;
  }
//----
  if(SymbolSet==""){
    if(Langvage_Ru_Engl){
      Comment(nolistru,"\n",entnamru);
    }else{
      Comment(nolisten,"\n",entnamen);
    }   
    prewtime=0;
    return;
  }
//----   -----------------------------------+
static int filecount=0;
bool c;
bool first=true;
int maxday = ArraySize(date)-1;
int summa=0,summb=0;
string filenm; 
//----
  if(!ShowHistory){
     filenm = SymbolSet+date[0]+ext;
        if(!busy()){request(filenm);}else{prewtime=TimeCurrent()+10;Print("wait 10 sek");return;}
        if(!ReadFile(filenm,date[filecount])){prewtime=0;return;}//     
        i=ArraySize(in)-1;
        tm0=TimeCurrent()+(Period()*OnlineFwdInBars*60)+timesdvig();
        tm1=StrToInteger(StringSubstr(in[i],0,10));     
        in[i]=StringSubstr(in[i],10);
        double pr13;
        if(tm1>=StrToTime(TimeToStr(TimeCurrent()-(86400*i),TIME_DATE))){
          for(x=0;x<15;x++){int pos,pos2,len;
             pos=StringFind(in[i],",",1);
             double callvol=nd(StrToDouble(StringSubstr(in[i],1,pos)));
             summa=summa+callvol;
             in[i]=StringSubstr(in[i],pos);         
             pos=StringFind(in[i],",",1);
             double prise0 =nd(StrToDouble(StringSubstr(in[i],1,pos)));
             in[i]=StringSubstr(in[i],pos);            
             pos=StringFind(in[i],",",1);
             double putvol =nd(StrToDouble(StringSubstr(in[i],1,pos)));
             summb=summb+putvol;
             in[i]=StringSubstr(in[i],pos);            
             pos=StringFind(in[i],",",1)+1;
             pos2=StringFind(in[i],",",pos+1);
             len=pos2-pos;
             if(x==13){pr13=prise0;}
             double prise1 =nd(StrToDouble(StringSubstr(in[i],pos,len)));
             if(x==14){prise1=prise0+(prise0-pr13);}
             SetRestangle(brite(callvol,putvol,summa,summb), x+"/"+tm1, tm0, prise0, tm1, prise1, DoubleToStr(callvol,0)+"/"+DoubleToStr(putvol,0));
             if(ShowText)SetText(true,txcol,tm0,prise0+((prise1-prise0)/2),DoubleToStr(callvol,0)+"/"+DoubleToStr(putvol,0),FontSize);             
          } 
          pos=StringFind(in[i],",",1)-1;
          allcalls="All Calls OI =" + StrToInteger(StringSubstr(in[i],1,pos));
          in[i]=StringSubstr(in[i],pos+1);
          pos=StringFind(in[i],",",1);
          tmexp = exp + TimeToStr(((StrToInteger(StringSubstr(in[i],1,pos-1))-25569)*86400),TIME_DATE);
          pos=StringFind(in[i],",",1);
          in[i]=StringSubstr(in[i],pos+1);
          pos=StringFind(in[i],",",1);
          allputs="All Puts OI =" + StrToInteger(StringSubstr(in[i],0,pos));
          in[i]=StringSubstr(in[i],pos+1);
          pos=StringFind(in[i],",",1);
          contrnm = cnm + StringSubstr(in[i],0,pos);
          in[i]=StringSubstr(in[i],pos);      
          ArrayResize(in,ArraySize(in)-1);  
          }        
  }else{
     if(filecount==0){ArrayResize(oi,0);}
     if(date[filecount]==0){recalcdate();prewtime=0;return;}//    
     filenm = SymbolSet+date[filecount]+ext;
     if(isfile(filenm)!=0){//    
        if(Langvage_Ru_Engl){
           Comment(zapflru,filenm);
        }else{
           Comment(zapflen,filenm);
        }      
        if(!busy()){request(filenm);}else{prewtime=TimeCurrent()+10;Print("wait 10 sek");return;}
        prewtime=0;
        return;
     }else{
        if(filecount==0){if(!busy()){request(filenm);}else{prewtime=TimeCurrent()+10;Print("wait 10 sek");return;}}//   
        if(Langvage_Ru_Engl){
           Comment(readflru,filenm);
        }else{
           Comment(readflen,filenm);
        }        
        if(!ReadFile(filenm,date[filecount])){prewtime=0;return;}//     
        if(filecount<maxday-1){//    
            filecount++;
            int szin=ArraySize(in);
            int szoi=ArraySize(oi);
            if(szoi<1&&szin<1){prewtime=0;return;}
            if(szoi<1){
               ArrayResize(oi,szin);
               ArraySetAsSeries(in,true);
               ArrayCopy(oi,in);
               ArraySetAsSeries(in,false);
            }else{
               ArrayResize(oi,szoi+szin);
               ArraySetAsSeries(in,true);
               ArrayCopy(oi,in,szoi);
               ArraySetAsSeries(in,false);
            }
        prewtime=0;    
        return;
        }
        delgr();
        Comment("  ");
        for(i=0;i<ArraySize(oi);i++){int tm00;
           if(i<1){
              tm0=TimeCurrent()+(Period()*OnlineFwdInBars*60)+timesdvig();
              tm1=StrToInteger(StringSubstr(oi[i],0,10));
           }else{
              tm0=tm00;
              tm1=StrToInteger(StringSubstr(oi[i],0,10));   
              if(tm1==0){tm1=tm0;}  
           }
          tm00=tm1;
          oi[i]=StringSubstr(oi[i],10);
          //----    
          int bar=iBarShift(Symbol(),1440,tm0,false);
          double maxprise = nd(iHigh(Symbol(),1440,bar));
          double minprise = nd(iLow(Symbol(),1440,bar));
          //----
          for(x=0;x<15;x++){
             pos=StringFind(oi[i],",",1);
             callvol=nd(StrToDouble(StringSubstr(oi[i],1,pos)));
             summa=summa+callvol;
             oi[i]=StringSubstr(oi[i],pos);         
             pos=StringFind(oi[i],",",1);
             prise0 =nd(StrToDouble(StringSubstr(oi[i],1,pos)));
             oi[i]=StringSubstr(oi[i],pos);            
             pos=StringFind(oi[i],",",1);
             putvol =nd(StrToDouble(StringSubstr(oi[i],1,pos)));
             summb=summb+putvol;
             oi[i]=StringSubstr(oi[i],pos);            
             pos=StringFind(oi[i],",",1)+1;
             pos2=StringFind(oi[i],",",pos+1);
             len=pos2-pos;
             if(x==13){pr13=prise0;}
             prise1 =nd(StrToDouble(StringSubstr(oi[i],pos,len)));
             if(x==14){prise1=prise0+(prise0-pr13);}
             int texttm = tm1 + ((tm0-tm1)/2);
             if(!ShowNearest){
               SetRestangle(brite(callvol,putvol,summa,summb), x+"/"+tm1, tm0, prise0, tm1, prise1, DoubleToStr(callvol,0)+"/"+DoubleToStr(putvol,0));
               if(ShowText)SetText(true,txcol,tm1,prise0+((prise1-prise0)/2),DoubleToStr(callvol,0)+"/"+DoubleToStr(putvol,0),FontSize); 
             }else{
               if(i<1){
                  SetRestangle(brite(callvol,putvol,summa,summb), x+"/"+tm1, tm0, prise0, tm1, prise1, DoubleToStr(callvol,0)+"/"+DoubleToStr(putvol,0));
                  if(ShowText)SetText(true,txcol,tm1+(Period()*OnlineFwdInBars*60),prise0+((prise1-prise0)/2),DoubleToStr(callvol,0)+"/"+DoubleToStr(putvol,0),FontSize); 
                  if(x==14){
                     pos=StringFind(oi[i],",",1)-1;
                     allcalls="All Calls OI =" + StrToInteger(StringSubstr(oi[i],1,pos));
                     oi[i]=StringSubstr(oi[i],pos+1);
                     pos=StringFind(oi[i],",",1);
                     tmexp = exp + TimeToStr(((StrToInteger(StringSubstr(oi[i],1,pos-1))-25569)*86400),TIME_DATE);
                     pos=StringFind(oi[i],",",1);
                     oi[i]=StringSubstr(oi[i],pos+1);
                     pos=StringFind(oi[i],",",1);
                     allputs="All Puts OI =" + StrToInteger(StringSubstr(oi[i],0,pos));
                     oi[i]=StringSubstr(oi[i],pos+1);
                     pos=StringFind(oi[i],",",1);
                     contrnm = cnm + StringSubstr(oi[i],0,pos);    
                  }                         
               }else{
               double str = (prise1-prise0)*2;
               if(prise1<=maxprise+str){
                 if(prise0>=minprise-str){
                   SetRestangle(brite(callvol,putvol,summa,summb), x+"/"+tm1, tm0, prise0, tm1, prise1, DoubleToStr(callvol,0)+"/"+DoubleToStr(putvol,0));
                   if(ShowText)SetText(false,txcol,tm1,prise0+((prise1-prise0)/2),DoubleToStr(callvol,0)+"/"+DoubleToStr(putvol,0),FontSize);                  
                 }
               }
             }
           }              
         }           
       }
      filecount=0;
    }     
  }
//+------------------------------------------------------------------+
    SetLabel("oicpo",copyrite,DimGray,1,1 ,1,9);
    SetLabel("oiexp",tmexp,   DimGray,1,15,1,9);
    SetLabel("oicnm",contrnm, DimGray,1,27,1,9);
    SetLabel("oiacl",allcalls,DimGray,1,41,1,9);
    SetLabel("oiapt",allputs, DimGray,1,56,1,9);
//+------------------------------------------------------------------+      
return;}
//+------------------------------------------------------------------+
int timesdvig(){
ArrayResize(tz,43);
ArrayInitialize(tz,0);
GetTimeZoneInformation(tz);
int srvho=TimeHour(TimeCurrent());
int sysho=TimeHour(TimeLocal());
int sdv=tz[0]/60;
int grn=sysho+sdv;
if(grn==24){grn=0;}
int res=srvho-(grn+1);
return((res*3600)*(-1));
}
//+------------------------------------------------------------------+
int GetWndColor(string sy)
   { 
     int hWnd = WindowHandle(sy, Period());
     int hDC = GetWindowDC(hWnd);
     int rect[4];
     GetWindowRect(hWnd, rect);
     int wW = rect[2] - rect[0];         //  
     int wH = rect[3] - rect[1];         //  
     
     int col = GetPixel(hDC, 2, 2);
     if(col==-1)                         //     
     {
       col = GetPixel(hDC, wW-3, wH-3); 
       if(col==-1)                       //     
       col = GetPixel(hDC, 2, wH-3); 
       if(col==-1)                       //     
       col = GetPixel(hDC, wW-3, 2);     
       if(col==-1)                       //     
       {
         ReleaseDC(hWnd, hDC);
         return(Win_color);
       }
      }
     ReleaseDC(hWnd, hDC);
     return(col);
   }
//+------------------------------------------------------------------+ 
color brite(double c,double p,double suma,double sumb)
{ int BB=0,RR=0,GG=0;double x,y;
  c=c+1;p=p+1;suma=suma+1;sumb=sumb+1;
  if(suma>5000){suma=5000;}
  if(sumb>5000){sumb=5000;}
  if(c>5000){c=5000;}
  if(p>5000){p=5000;} 
  if(Britness>255){Britness=255;}   
  if(Britness<0){Britness=0;}    
  if(c>p){
   if(GetWndColor(Symbol())<=0){
   x=(MathSqrt(c/suma))*255;
   BB=Britness;
   GG=Britness;
   RR=x;
   }else{
   x=(MathSqrt(c/suma))*255-Britness;
   if(x>255){x=255;}
   BB=255-x;
   GG=255-x;
   RR=255;
   }   
  return((BB<<16)^(GG<<8)^(RR));
  }else{
   if(GetWndColor(Symbol())<=0){
     y=(MathSqrt(p/sumb))*255;
     BB=y;
     GG=Britness;
     RR=Britness; 
   }else{
     y=(MathSqrt(p/sumb))*255-Britness;
     BB=255;
     GG=255-y;
     RR=255-y; 
   }     
  return((BB<<16)^(GG<<8)^(RR)); 
  }
  return((BB<<16)^(GG<<8)^(RR));
}
//+------------------------------------------------------------------+
bool newday(){if(TimeHour(TimeCurrent())+(timesdvig()/3600)>=0){return(true);}else{return(false);}}
//+------------------------------------------------------------------+
void recalcdate(){days=DepthHistoryInDays;
  ArrayResize(date,100);
  ArrayInitialize(date,0);
  int x=0;
  int time_0=TimeHour(TimeCurrent())+(timesdvig()/3600);
  if(time_0<0){days++;}
  for(int i=0;i<=days;i++){
    if(i==0){if(time_0<0){i=1;}}
    if(TimeDayOfWeek(StrToTime(TimeToStr(TimeCurrent()-(86400*i),TIME_DATE)))!=0&&
       TimeDayOfWeek(StrToTime(TimeToStr(TimeCurrent()-(86400*i),TIME_DATE)))!=6){
      date[x]=StrToTime(TimeToStr(TimeCurrent()-(86400*i),TIME_DATE));
      x++;
    }else{days++;}  
  }
  ArrayResize(date,x+1);
return;
}
//+------------------------------------------------------------------+ 
void delgr(){
   for(int i=ObjectsTotal();i>=0;i--){
     if("oitxt"==StringSubstr(ObjectName(i),0,5)){ObjectDelete(ObjectName(i));}
     if("opint"==StringSubstr(ObjectName(i),0,5)){ObjectDelete(ObjectName(i));}
     if("oionl"==StringSubstr(ObjectName(i),0,5)){ObjectDelete(ObjectName(i));}
   }
return;
}   
//+------------------------------------------------------------------+
string SymbolControl(){string in[100];string sy="404";int hd;
   hd=FileOpen(symbols,FILE_CSV|FILE_READ,";"); 
   if(hd<0){return(sy);}
   sy="";
   for(int i=0;i<100;i++){
     in[i]=FileReadString(hd);
     if(FileIsEnding(hd)){break;}
   }  
   ArrayResize(in,i);
   FileClose(hd);
   for(int x=0;x<=i;x++){
     if(StringFind(in[x],Symbol(),0)>=0){
       int count=StringFind(in[x],",",0);
       sy=StringSubstr(in[x],0,count);
     }  
   }  
return(sy);
}
//+------------------------------------------------------------------+
double nd(double in){return(NormalizeDouble(in,Digits));}
//+------------------------------------------------------------------+
void SetLabel(string nm, string tx, color cl, int xd, int yd, int cr=0, int fs=9) {
  if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_LABEL, 0, 0,0);
  ObjectSetText(nm, tx,fs,"Times new roman", cl);
  ObjectSet(nm, OBJPROP_COLOR    , cl);
  ObjectSet(nm, OBJPROP_XDISTANCE, xd);
  ObjectSet(nm, OBJPROP_YDISTANCE, yd);
  ObjectSet(nm, OBJPROP_CORNER   , cr);
  ObjectSet(nm, OBJPROP_FONTSIZE , fs);
  ObjectSet(nm, OBJPROP_BACK , false);
}
//+------------------------------------------------------------------+
void SetRestangle(color cl, string nm="",datetime t1=0, double p1=0, 
                  datetime t2=0, double p2=0,string vol=""){
  nm="opint "+nm;
  if(ObjectFind(nm)<0)ObjectCreate(nm, OBJ_RECTANGLE, 0, 0,0, 0,0);
  ObjectSet(nm, OBJPROP_TIME1 , t2-timesdvig());
  ObjectSet(nm, OBJPROP_PRICE1, p1);
  ObjectSet(nm, OBJPROP_TIME2 , t1-timesdvig());
  ObjectSet(nm, OBJPROP_PRICE2, p2);
  ObjectSet(nm, OBJPROP_COLOR , cl);
  ObjectSet(nm, OBJPROP_RAY   , false);
  ObjectSet(nm, OBJPROP_STYLE , 0);
  ObjectSet(nm, OBJPROP_WIDTH , 1);
  ObjectSetText(nm,vol,3,"Arial",White);
  ObjectSet(nm, OBJPROP_BACK , FillRestangle);
}
//+------------------------------------------------------------------+   
void SetText(bool eraze,color cl,int t1,double p1,string tx="",int razm=8){string nm;
  if(!eraze){
    nm="oitxt"+tx+p1;
    if(ObjectFind(nm)<0){ObjectCreate(nm, OBJ_TEXT, 0, 0,0, 0,0);}
      ObjectSet(nm, OBJPROP_TIME1 , t1-timesdvig());
      ObjectSet(nm, OBJPROP_PRICE1, p1);
      ObjectSetText(nm,tx,razm,FontName,cl);
      ObjectSet(nm, OBJPROP_BACK , false);    
  }else{
    nm="oionl"+tx+p1;
    ObjectCreate(nm, OBJ_TEXT, 0, 0,0, 0,0);
    ObjectSet(nm, OBJPROP_TIME1 , t1-timesdvig());
    ObjectSet(nm, OBJPROP_PRICE1, p1);
    ObjectSetText(nm,tx,razm,FontName,cl);
    ObjectSet(nm, OBJPROP_BACK , false);  
  }  

return;
}
//+------------------------------------------------------------------+
bool ReadFile(string fn,int tm){int i, hd; 
   ArrayResize(in,100);
   hd=FileOpen(fn,FILE_CSV|FILE_READ,";"); 
   if(hd<0){return(false);}
    string res=FileReadString(hd);
    if(res=="404"){
      FileClose(hd);
      return(false);
    }   
   FileSeek(hd,SEEK_SET,0); 
   for(i=0;i<100;i++){
     res=FileReadString(hd);
     if(StringSubstr(res,0,2)=="12"){in[i]=res;}else{break;}
     if(FileIsEnding(hd)){break;}
   }  
   ArrayResize(in,i-1);
   FileClose(hd);
   return(true);
} 
//+------------------------------------------------------------------+
int isfile(string fn){
  int hd = FileOpen(fn,FILE_CSV|FILE_READ,";");
  if( hd>0){
    string res=FileReadString(hd);
    if(res=="404"){
      FileClose(hd);
      return(404);
    }  
    FileClose(hd);
    return(0);
  }else{return(GetLastError());}
}